来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum
给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:
输入:nums = [3,2,4], target = 6
输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6
输出:[0,1]
1、暴力求解
第一种解法:暴力求解。通过循环的形式将数组中的每两个数字都相加一遍,记录两数和为目标值的下标
效率不会高,两层循环,时间复杂度会到O(n的平方)
class Solution {
public int[] twoSum(int[] nums, int target) {
int [] result = new int[2];
for(int i=0;i<nums.length;i++){
for(int j=i+1;j<nums.length;j++){
if(nums[i]+nums[j] == target){
result[0]=i;
result[1]=j;
}
}
}
return result;
}
}
2、第二种方式求解,通过HashMap
,
用目标值减去从数组取出的某一个值。将新获得的值从哈希表里遍历。看是否存在。如果存在、直接取出hash表中该值的下标和当前下标。如果不存在,则将减去的数存放入哈希表。key存储值,value存储下标。
一些预备知识
代码实现
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer,Integer> storeMap = new HashMap<>(nums.length,1);
int [] result = new int[2];
for(int i=0;i<nums.length;i++){
int another = target-nums[i];
if(null != storeMap.get(another)){
result[0] = storeMap.get(another);
result[1] = i;
break;
}else{
storeMap.put(nums[i],i);
}
}
return result;
}
}